%              Corso di informatica industriale                    %
%                                                                  %
%               Script risoluzione esercizio 6                     %
%           Esercitazione in laboratorio del 23/1/2009             %
%******************************************************************%
% Testo: Calcolare e graficare l'andamento della posizione del pistone in
% un manovellismo di spinta

%% Pulizia dell'ambiente di lavoro, prima di intraprendere la soluzione

clear  %pulizia completa dell workspace
clc    %Pulizia del Command window

%% Inserimento dati
%Note: il comando 'disp' ha la sola funzione di visualizzare a video
%      le operazioni effettuate dallo script

%Prima inserisco i dati geometrici del manovellismo
disp('>> L1=1')
L1=1
disp('>> L2=0.5')
L2=0.5

% Calcolo la posizione del posizione in base all'angolo A, pertanto occore
% generare un vettore contenente vari valori dell'angolo, nell'arco di un
% giro. Ricordando che l'angolo dev'essere espresso in radianti, si sceglie
% la precisione del calcolo, quindi la differenza dell'angolo tra un
% elemento e il suo successivo. Inoltre voglio analizzare i 2 giri;
% pertanto parto da A=0 rad fino ad A=4*pi rad, con incremento 0.01 rad.
% Il vettore avr dimensione 1257 
disp('>> A=0:0.01:4*pi;')
A=0:0.01:4*pi;

disp('premi un tasto per continuare...')
pause

%% Risoluzione esercizio

% Come si nota dal disegno riportato sui lucidi delle esercitazioni, la
% posizione del pistone pu essere individuata dalla somma delle proiezioni
% della biella e della manovella lungo l'asse di simmetria del meccanismo.
% Pertanto sar d=L1*cos(B) + L2*cos(A), dove B angolo incognito,
% dipendente dalla posizione angolare A.
% B si ricava facilmente dall'equazione L1*sen(B)=L2*sen(A). Di conseguenza
%  sufficiente riportare le formule risolutive del problema; essendo A un
% vettore, sia B che d saranno vettori della medesima dimensione, dove
% l'i-esimo elemento di d e B sono i valori calcolati usando l'i-esimo
% elemento in A.

%NB: si utilizza l'inversa del seno! help asin per ulteriori informazioni
disp('>> B=asin(L2/L1*sin(A));')
B=asin(L2/L1*sin(A));

disp('>> d=L1*cos(B)+L2*cos(A);')
d=L1*cos(B)+L2*cos(A);

% Infine si chiede di graficare. A tal scopo si usa la funzione 'plot',
% passando come argomenti il vettore A (ingresso al sistema, valori in
% ascissa) ed il vettore d (uscita del sistema, valori in ordinata).
disp('>> plot(A,d)')
plot(A,d)

